import threading
import queue
import time 
#import datetime
import sys
import asyncio
import nest_asyncio
from breeze_connect import BreezeConnect
from datetime import datetime

#nest_asyncio.apply()

class Strategies:
    
    #initialize strategy object
    def __init__(self,app_key,secret_key,api_session,max_profit,max_loss):
        
        self.maxloss = int(max_loss)
        self.maxprofit = int(max_profit)
        self.currentcall = 0
        self.currentput = 0
        self.flag = False
        self.client = BreezeConnect(app_key)
        self.client.generate_session(secret_key,api_session)
        
        self.quantity = 0
        self.exchange_code = ""
        self.stock_code = ""
        self.product_type = ""
        self.expiry_date = ""
        self.strike_price = ""
        self.order_type = ""
        self.validity = ""
        self.stoploss = ""
        self.validity_date = ""
        self.callexecution = ""
        self.putexecution = ""
        self.strategy_type = ""
        self.socket = 0
    
    def squareoff(self,exchange_code, stock_code, product_type, expiry_date, strike_price, order_type, validity, stoploss, quantity, price,validity_date, trade_password, disclosed_quantity,right):
        action = "buy"
        if(self.strategy_type.lower() == "short"):
            action = "buy"
        else:
            action = "sell"

        data = self.client.square_off(exchange_code=exchange_code,
                            product="options",
                            stock_code=stock_code,
                            expiry_date=expiry_date,
                            right=right,
                            strike_price=strike_price,
                            action=action,
                            order_type=order_type,
                            validity=validity,
                            stoploss="0",
                            quantity=quantity,
                            price=price,
                            validity_date=validity_date,
                            trade_password="",
                            disclosed_quantity="0")

        print(f"Squaring off {right} ..")
        response = None
        if(data['Status'] == 200):
            response = data['Success']['message']
            print(f"Success : {response}")
        else:
            response = data['Error']
            print(f"Error : {response}")
        return(data)
        
    def get_date_format(self,expiry_date):
        month_names = {
                            '01': 'Jan',
                            '02': 'Feb',
                            '03': 'Mar',
                            '04': 'Apr',
                            '05': 'May',
                            '06': 'Jun',
                            '07': 'Jul',
                            '08': 'Aug',
                            '09': 'Sep',
                            '10': 'Oct',
                            '11': 'Nov',
                            '12': 'Dec'
                      }
        year = expiry_date[:4]
        month = expiry_date[5:7]
        day = expiry_date[8:10]
        formatted_date = f"{day}-{month_names[month]}-{year}"
        return(formatted_date)
        
    def trigger(self,product_type, rightval, stock_code, strike_price, quantity, expiry_date, order_type, validity, validity_date, exchange_code, stoploss, call_price, put_price, call_execution,put_execution):
        net_gain_loss = (self.currentcall + self.currentput)*int(quantity)
        print(f"P&L (NET) : {round(net_gain_loss,2)}/- Rs")
        print("----------------------------------------")
        formatted_date = self.get_date_format(expiry_date)

        if(net_gain_loss > 0 and net_gain_loss >= self.maxprofit):
            print("TakeProfit reached...")
            #print("SquareOff operation on both contracts call and put begins....")
            
            
            self.client.unsubscribe_feeds(exchange_code=exchange_code, stock_code=stock_code, product_type="options", expiry_date= formatted_date, strike_price=strike_price, right="Call", get_exchange_quotes=True, get_market_depth=False)
            self.client.unsubscribe_feeds(exchange_code=exchange_code, stock_code=stock_code, product_type="options", expiry_date= formatted_date, strike_price=strike_price, right="Put", get_exchange_quotes=True, get_market_depth=False)
            self.stop()
            
            self.flag = True
            return
        if(net_gain_loss < 0 and net_gain_loss <= self.maxloss):
            print("MaxLoss reached...")
            #print("SquareOff operation on both contracts call and put begins....")
            
            self.client.unsubscribe_feeds(exchange_code=exchange_code, stock_code=stock_code, product_type="options", expiry_date= formatted_date, strike_price=strike_price, right="Call", get_exchange_quotes=True, get_market_depth=False)
            self.client.unsubscribe_feeds(exchange_code=exchange_code, stock_code=stock_code, product_type="options", expiry_date= formatted_date, strike_price=strike_price, right="Put", get_exchange_quotes=True, get_market_depth=False)
            self.stop()
           
            self.flag = True
            return

    def calculate_current(self,product_type,stock_code, strike_price, quantity, expiry_date, order_type, validity, validity_date, exchange_code, stoploss, call_price,put_price,call_execution,put_execution,flag):
        
        resultcall = []
        formatted_date = self.get_date_format(expiry_date)
        
        def on_ticks(data):
            
            value = data
            
            if(value['right'] == "Call"):
                self.currentcall = round(float(value['last']) - float(call_execution), 2)
                if(self.strategy_type.lower() == "short"):
                    self.currentcall = self.currentcall*-1
                if(self.flag == False):
                    self.trigger(product_type, "Call", stock_code, strike_price, quantity, expiry_date, order_type, validity, validity_date, exchange_code, stoploss, call_price,put_price,call_execution,put_execution)
            
            if(value['right'] == "Put"):
                self.currentput = round(float(value['last']) - float(put_execution), 2)
                if(self.strategy_type.lower() == "short"):
                    self.currentput = self.currentput*-1
                if(self.flag == False):
                    self.trigger(product_type, "Put", stock_code, strike_price, quantity, expiry_date, order_type, validity, validity_date, exchange_code, stoploss, call_price,put_price,call_execution,put_execution)
            
        self.client.on_ticks = on_ticks
        self.client.subscribe_feeds(exchange_code = exchange_code, stock_code = stock_code, product_type = product_type, expiry_date= formatted_date, strike_price=strike_price, right = "Call", get_exchange_quotes=True, get_market_depth=False)
        self.client.subscribe_feeds(exchange_code = exchange_code, stock_code = stock_code, product_type = product_type, expiry_date= formatted_date, strike_price=strike_price, right = "Put", get_exchange_quotes=True, get_market_depth=False) 

        
    def profit_and_loss(self,product_type, stock_code, strike_price, quantity, expiry_date, order_type, validity, validity_date, exchange_code, stoploss, call_price, put_price, orderids,call_execution,put_execution):
        self.calculate_current(product_type, stock_code, strike_price, quantity, expiry_date, order_type, validity, validity_date, exchange_code, stoploss, call_price, put_price, call_execution, put_execution,False)
            
    def straddle(self, strategy_type,stock_code, strike_price, quantity, expiry_date, stoploss = "", put_price = "0", call_price = "0",product_type = "options", order_type = "market", validity = "day", validity_date = datetime.utcnow().strftime('%Y-%m-%dT%H:%M:%S.%fZ'), exchange_code = "NFO"):
        
        self.quantity = quantity
        self.strategy_type = strategy_type
        self.exchange_code = exchange_code 
        self.stock_code = stock_code
        self.product_type = product_type 
        self.expiry_date = expiry_date  
        self.strike_price = strike_price
        self.order_type = order_type
        self.validity = validity
        self.stoploss = stoploss
        #self.quantity = quantity
        self.validity_date = validity_date
        
        if(self.socket == 0):
            self.client.ws_connect()
            self.socket = 1
            

        if(strategy_type.lower() not in ["long","short"]):
            return("strategy_type should be either long or short..")

        def place_order_method(stock_code,exchange_code,product,action,order_type,stoploss,quantity,price,validity,validity_date,expiry_date,right,strike_price,res_queue):
         
            data =  self.client.place_order(stock_code=stock_code,
                    exchange_code=exchange_code,
                    product="options",
                    action = action,
                    order_type=order_type,
                    stoploss=stoploss,
                    quantity=quantity,
                    price = price,
                    validity= validity,
                    validity_date = validity_date,
                    disclosed_quantity = "0",
                    expiry_date = expiry_date,
                    right= right,
                    strike_price=strike_price)
            response = None
            if(data['Status'] == 200):
                response = data['Success']['message']
                print(f"Success : {response} for {right} with order_id :{data['Success']['order_id']}")
                res_queue.put(data)
            else:
                response = data['Error']
                print(f"Error : {response} for {right}")
                res_queue.put(data)
            return(data)
                  
        res_queue = queue.Queue()
        action = "buy"

        if(strategy_type.lower()== "short"):
            action = "sell"
        
        #create thread for call and put order to execute simultaneously for buy type
        t1 = threading.Thread(target = place_order_method,args = (stock_code,exchange_code,"options",action,order_type,stoploss,quantity,call_price,validity,validity_date,expiry_date,"Call",strike_price,res_queue))
        t1.start()
        t1.join()
        
        firstresponse = res_queue.get()
        
        res_queue = queue.Queue()
        t2 = threading.Thread(target = place_order_method,args = (stock_code,exchange_code,"options",action,order_type,stoploss,quantity,put_price,validity,validity_date,expiry_date,"Put",strike_price,res_queue))
        t2.start()
        t2.join()
        secondresponse = res_queue.get()
        
        
        #if one of the order fails then cancel the other one which is successfull
        if(firstresponse.get('Status')==200 and secondresponse.get('Status')==500):
            print("Put Order Failed....")
            order_id = firstresponse['Success']['order_id']
            data  = self.client.cancel_order(exchange_code=exchange_code,
                    order_id = order_id)

            if(data.get("Success",None) == None):
                print("Call Order Cancellation has not been successfull")
                print("----------END-------------------")
            else:
                print("Call Order Cancellation has  been successfull")
                print("----------END-------------------")
            
            
        
        elif(secondresponse.get('Status')==200 and firstresponse.get('Status')==500):
            print("Call order failed....")
            order_id = secondresponse['Success']['order_id']
            
            data = self.client.cancel_order(exchange_code=exchange_code,
                    order_id = order_id)
            
            if(data.get("Success",None) == None):
                print("Put Order Cancellation has not been successfull")
            else:
                print("Put Order Cancellation has  been successfull")
            
        
        elif(firstresponse.get('Success',None)==None and secondresponse.get('Success',None)==None):
            print("both order call and put have failed")
            print("------------END----------------")
            
        
        else:
            orderids = [] #0th index will contain call order, #1st index will contain put order 
            orderids.append(firstresponse['Success']['order_id']) 
            orderids.append(secondresponse['Success']['order_id'])            
            #define a mechanism to get profit and loss
            print("\n")
            print("----Starting live P&L feed...---")
            time.sleep(5)
            details = self.client.get_order_detail(exchange_code=exchange_code,
                        order_id= orderids[0])

            call_status = None
            put_status = None

            #print(details)
            call_execution = -1
            put_execution = -1
            
            #print(f"order ids are : {orderids}")
            for entry in details['Success']:
                if(entry['status'] == "Executed"):
                    call_execution = entry['average_price']
                    call_status = "Executed"
                    self.callexecution = call_execution
                    break
                    
            details = self.client.get_order_detail(exchange_code=exchange_code,
                        order_id= orderids[1])
            #print(details)
            for entry in details['Success']:
                if(entry['status'] == "Executed"):
                    put_execution = entry['average_price']
                    put_status = "Executed"
                    self.putexecution = put_execution
                    break
                    
            if(call_execution == -1 or put_execution == -1):
                print("Dear User order could not execute within time limit ..cancelling it")
                
                
                if(call_execution == -1 and put_execution == -1):
                    print("Both Order Call and Put could not execute to so cancelling it ..... ")
                    self.client.cancel_order(exchange_code=exchange_code,
                    order_id = orderids[0])
                    self.client.cancel_order(exchange_code=exchange_code,
                    order_id = orderids[1])

                elif(call_execution == -1):
                    #call cancel order api
                    print("call order could not execute due to some reason so cancelling order")
                    #self.squareoff(self,rightval,exchange_code, stock_code, product_type, expiry_date, right, strike_price, action, order_type, validity, stoploss, quantity, price,validity_date, trade_password, disclosed_quantity)
                    self.client.cancel_order(exchange_code=exchange_code,
                    order_id = orderids[0])

                    print("put order is executed squaring off....")
                    
                    self.squareoff(exchange_code = self.exchange_code, stock_code = self.stock_code, product_type = self.product_type , expiry_date = self.expiry_date , strike_price = self.strike_price , order_type = self.order_type, validity = self.validity, stoploss = self.stoploss, quantity = self.quantity, price = "", validity_date = self.validity_date, trade_password = "", disclosed_quantity="0",right = "Put")

                elif(put_execution == -1):
                    #call cancel order api
                    print("put order could not execute due to some reason so cancelling order")
                    status = self.client.cancel_order(exchange_code=exchange_code,
                    order_id = orderids[1])
                    print("call order is executed squaring off....")
                    self.squareoff(exchange_code = self.exchange_code, stock_code = self.stock_code, product_type = self.product_type , expiry_date = self.expiry_date , strike_price = self.strike_price , order_type = self.order_type, validity = self.validity, stoploss = self.stoploss, quantity = self.quantity, price = "", validity_date = self.validity_date, trade_password = "", disclosed_quantity="0",right = "Call")
                    
            else:
                print("Call order got executed at price :{0} Rs and Put Order got executed at price : {1} Rs".format(call_execution,put_execution))
                self.profit_and_loss(product_type, stock_code, strike_price, quantity, expiry_date, order_type, validity, validity_date, exchange_code, stoploss, call_price, put_price, orderids,call_execution,put_execution)
            
    
    
    
    def stop(self):
        if(self.socket == 1):
            self.client.ws_disconnect()
        self.socket = 0
        time.sleep(1)
        print("\n")
        print("Squaring off the both contracts and exiting strategy...")
        print("----------------------------------------")
        
        square_call = self.squareoff(exchange_code = self.exchange_code, stock_code = self.stock_code, product_type = self.product_type , expiry_date = self.expiry_date , strike_price = self.strike_price , order_type = self.order_type, validity = self.validity, stoploss = self.stoploss, quantity = self.quantity, price = "", validity_date = self.validity_date, trade_password = "", disclosed_quantity="0",right = "Call")
        square_put = self.squareoff(exchange_code = self.exchange_code, stock_code = self.stock_code, product_type = self.product_type , expiry_date = self.expiry_date , strike_price = self.strike_price , order_type = self.order_type, validity = self.validity, stoploss = self.stoploss, quantity = self.quantity, price = "", validity_date = self.validity_date, trade_password = "", disclosed_quantity="0",right = "Put")
        print("----------------------------------------")
        self.create_report(square_call,square_put)
        

    def get_pnl(self):
        
        outcome = (self.currentcall + self.currentput)*int(self.quantity)
        print(f"P&L (NET) : {round(outcome,2)}/- Rs")

        print("----------------------------------------")


    def create_report(self,sq_call,sq_put):
        
        if(sq_call['Status'] == 200 and sq_put['Status'] == 200):
            sq_callid = sq_call["Success"]['order_id']
            sq_putid = sq_put["Success"]['order_id']

            print("\nGenerating Final P&L report in 5 seconds....")
            time.sleep(5)
            callrecords = self.client.get_order_detail(exchange_code=self.exchange_code,
                        order_id= sq_callid)

            putrecords = self.client.get_order_detail(exchange_code=self.exchange_code,
                        order_id= sq_putid)

            sqcall_price = -1
            sqput_price = -1
            time.sleep(5)
            for record in callrecords['Success']:
                if(record['status'] == "Executed"):
                    sqcall_price = record["average_price"]
                    break
            for record in putrecords["Success"]:
                if(record['status'] == "Executed"):
                    sqput_price = record["average_price"]
                    break
            
            plcall = round((float(sqcall_price) - float(self.callexecution))*int(self.quantity),2)
            plput = round((float(sqput_price) - float(self.putexecution))*int(self.quantity),2)

            self.currentcall = (float(sqcall_price) - float(self.callexecution))
            self.currentput = (float(sqput_price) - float(self.putexecution))

            print("----------------------------------------")
            print("Profit and Loss Report........")
            print(f"P&L (CALL) : {plcall}/- Rs")
            print(f"P&L (PUT) : {plput}/- Rs")
            print(f"P&L (NET) : {plput + plcall}/- Rs")
            print("----------------------------------------")
        else:
            print("One of Square off operation failed..")



